import { NativeModules } from 'react-native';

const TencentCloudPush = NativeModules.TencentCloudPush ? NativeModules.TencentCloudPush : {};
const LOG_PREFIX = 'Push js |';
export default class Push {
  private constructor() {}
  static registerPush(SDKApppID: number, appKey: string, onSuccess: (data: string) => void, onError?: (errCode: number, errMsg: string) => void): void {
    console.log(LOG_PREFIX, 'registerPush', SDKApppID, appKey);
    if (typeof onError === 'function') {
      TencentCloudPush.registerPushWithOnError(SDKApppID, appKey, onSuccess, onError);
    } else {
      TencentCloudPush.registerPush(SDKApppID, appKey, onSuccess);
    }
  }

  static unRegisterPush(onSuccess: () => void, onError?: (errCode: number, errMsg: string) => void) {
    console.log(LOG_PREFIX, 'unRegisterPush');
    if (typeof onError === 'function') {
      TencentCloudPush.unRegisterPushWithOnError(onSuccess, onError);
    } else {
      TencentCloudPush.unRegisterPush(onSuccess);
    }
  }

  static getRegistrationID(onSuccess: (registrationID: string) => void): void {
    console.log(LOG_PREFIX, 'getRegistrationID');
    TencentCloudPush.getRegistrationID(onSuccess);
  }

  static setRegistrationID(registrationID: string,  onSuccess: () => void): void {
    console.log(LOG_PREFIX, 'setRegistrationID', registrationID);
    TencentCloudPush.setRegistrationID(registrationID, onSuccess);
  }

  static getNotificationExtInfo(onSuccess: (extInfo: string) => void): void {
    console.log(LOG_PREFIX, 'getNotificationExtInfo');
    TencentCloudPush.getNotificationExtInfo(onSuccess);
  }
}
